-- MySQL dump 10.13  Distrib 8.0.25, for Win64 (x86_64)
--
-- Host: mysql-prokudin.mysql.database.azure.com    Database: compprehension_app2
-- ------------------------------------------------------
-- Server version	5.6.47.0

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!50503 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `answer_object`
--

DROP TABLE IF EXISTS `answer_object`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `answer_object` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `answer_id` int(11) NOT NULL,
  `hyper_text` varchar(255) DEFAULT NULL,
  `domain_info` varchar(1000) DEFAULT NULL,
  `is_right_col` bit(1) DEFAULT NULL,
  `concept` varchar(255) DEFAULT NULL,
  `question_id` bigint(20) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `uk_answerId__questionId` (`answer_id`,`question_id`),
  KEY `FK_ANSWEROBJECT_ON_QUESTION` (`question_id`),
  CONSTRAINT `FK_ANSWEROBJECT_ON_QUESTION` FOREIGN KEY (`question_id`) REFERENCES `question` (`id`)
) /*!50100 TABLESPACE `innodb_system` */ ENGINE=InnoDB AUTO_INCREMENT=33384 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `correct_law`
--

DROP TABLE IF EXISTS `correct_law`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `correct_law` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `interaction_id` bigint(20) NOT NULL,
  `law_name` varchar(255) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_CORRECTLAW_ON_INTERACTION` (`interaction_id`),
  CONSTRAINT `FK_CORRECTLAW_ON_INTERACTION` FOREIGN KEY (`interaction_id`) REFERENCES `interaction` (`id`)
) /*!50100 TABLESPACE `innodb_system` */ ENGINE=InnoDB AUTO_INCREMENT=19287 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `databasechangelog`
--

DROP TABLE IF EXISTS `databasechangelog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `databasechangelog` (
  `ID` varchar(255) NOT NULL,
  `AUTHOR` varchar(255) NOT NULL,
  `FILENAME` varchar(255) NOT NULL,
  `DATEEXECUTED` datetime NOT NULL,
  `ORDEREXECUTED` int(11) NOT NULL,
  `EXECTYPE` varchar(10) NOT NULL,
  `MD5SUM` varchar(35) DEFAULT NULL,
  `DESCRIPTION` varchar(255) DEFAULT NULL,
  `COMMENTS` varchar(255) DEFAULT NULL,
  `TAG` varchar(255) DEFAULT NULL,
  `LIQUIBASE` varchar(20) DEFAULT NULL,
  `CONTEXTS` varchar(255) DEFAULT NULL,
  `LABELS` varchar(255) DEFAULT NULL,
  `DEPLOYMENT_ID` varchar(10) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `databasechangeloglock`
--

DROP TABLE IF EXISTS `databasechangeloglock`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `databasechangeloglock` (
  `ID` int(11) NOT NULL,
  `LOCKED` bit(1) NOT NULL,
  `LOCKGRANTED` datetime DEFAULT NULL,
  `LOCKEDBY` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`ID`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `domain`
--

DROP TABLE IF EXISTS `domain`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `domain` (
  `name` varchar(255) NOT NULL,
  `version` varchar(255) NOT NULL,
  `short_name` varchar(255) NOT NULL,
  `options_json` json NOT NULL,
  PRIMARY KEY (`name`),
  UNIQUE KEY `uc_e7da9cda2c1460840f30fc189` (`name`,`version`),
  UNIQUE KEY `uc_domain_shortname` (`short_name`)
) /*!50100 TABLESPACE `innodb_system` */ ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `exercise`
--

DROP TABLE IF EXISTS `exercise`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `exercise` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) DEFAULT NULL,
  `max_retries` int(11) DEFAULT NULL,
  `use_guiding_questions` bit(1) DEFAULT NULL,
  `hidden` bit(1) DEFAULT NULL,
  `tags` varchar(255) NOT NULL,
  `options_json` json NOT NULL,
  `exercise_type` int(11) DEFAULT NULL,
  `language_id` int(11) DEFAULT NULL,
  `domain_id` varchar(255) NOT NULL,
  `backend_id` varchar(100) NOT NULL,
  `strategy_id` varchar(100) NOT NULL,
  `complexity` float NOT NULL,
  `stages_json` json NOT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_EXERCISE_ON_DOMAIN` (`domain_id`),
  CONSTRAINT `FK_EXERCISE_ON_DOMAIN` FOREIGN KEY (`domain_id`) REFERENCES `domain` (`name`)
) /*!50100 TABLESPACE `innodb_system` */ ENGINE=InnoDB AUTO_INCREMENT=29 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `exercise_attempt`
--

DROP TABLE IF EXISTS `exercise_attempt`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `exercise_attempt` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `attempt_status` int(11) DEFAULT NULL,
  `exercise_id` bigint(20) NOT NULL,
  `user_id` bigint(20) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_EXERCISEATTEMPT_ON_EXERCISE` (`exercise_id`),
  KEY `FK_EXERCISEATTEMPT_ON_USER` (`user_id`),
  CONSTRAINT `FK_EXERCISEATTEMPT_ON_EXERCISE` FOREIGN KEY (`exercise_id`) REFERENCES `exercise` (`id`),
  CONSTRAINT `FK_EXERCISEATTEMPT_ON_USER` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`)
) /*!50100 TABLESPACE `innodb_system` */ ENGINE=InnoDB AUTO_INCREMENT=405 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `exercise_question_type`
--

DROP TABLE IF EXISTS `exercise_question_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `exercise_question_type` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `exercise_id` bigint(20) NOT NULL,
  `question_type` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_EXERCISEQUESTIONTYPE_ON_EXERCISE` (`exercise_id`),
  CONSTRAINT `FK_EXERCISEQUESTIONTYPE_ON_EXERCISE` FOREIGN KEY (`exercise_id`) REFERENCES `exercise` (`id`)
) /*!50100 TABLESPACE `innodb_system` */ ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `explanation_template_info`
--

DROP TABLE IF EXISTS `explanation_template_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `explanation_template_info` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `field_name` varchar(255) DEFAULT NULL,
  `value` varchar(255) DEFAULT NULL,
  `violation_id` bigint(20) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_EXPLANATIONTEMPLATEINFO_ON_VIOLATION` (`violation_id`),
  CONSTRAINT `FK_EXPLANATIONTEMPLATEINFO_ON_VIOLATION` FOREIGN KEY (`violation_id`) REFERENCES `violation` (`id`)
) /*!50100 TABLESPACE `innodb_system` */ ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feedback`
--

DROP TABLE IF EXISTS `feedback`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `feedback` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `grade` float DEFAULT NULL,
  `interactions_left` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2998 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `interaction`
--

DROP TABLE IF EXISTS `interaction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `interaction` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `order_number` int(11) DEFAULT NULL,
  `last_supplementary_question` varchar(255) DEFAULT NULL,
  `interaction_type` varchar(255) DEFAULT NULL,
  `feedback_id` bigint(20) DEFAULT NULL,
  `question_id` bigint(20) NOT NULL,
  `date` datetime(6) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_INTERACTION_ON_FEEDBACK` (`feedback_id`),
  KEY `FK_INTERACTION_ON_QUESTION` (`question_id`),
  CONSTRAINT `FK_INTERACTION_ON_FEEDBACK` FOREIGN KEY (`feedback_id`) REFERENCES `feedback` (`id`),
  CONSTRAINT `FK_INTERACTION_ON_QUESTION` FOREIGN KEY (`question_id`) REFERENCES `question` (`id`)
) /*!50100 TABLESPACE `innodb_system` */ ENGINE=InnoDB AUTO_INCREMENT=2969 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `jobrunr_backgroundjobservers`
--

DROP TABLE IF EXISTS `jobrunr_backgroundjobservers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `jobrunr_backgroundjobservers` (
  `id` char(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `workerPoolSize` int(11) NOT NULL,
  `pollIntervalInSeconds` int(11) NOT NULL,
  `firstHeartbeat` datetime(6) NOT NULL,
  `lastHeartbeat` datetime(6) NOT NULL,
  `running` int(11) NOT NULL,
  `systemTotalMemory` bigint(20) NOT NULL,
  `systemFreeMemory` bigint(20) NOT NULL,
  `systemCpuLoad` decimal(3,2) NOT NULL,
  `processMaxMemory` bigint(20) NOT NULL,
  `processFreeMemory` bigint(20) NOT NULL,
  `processAllocatedMemory` bigint(20) NOT NULL,
  `processCpuLoad` decimal(3,2) NOT NULL,
  `deleteSucceededJobsAfter` varchar(32) DEFAULT NULL,
  `permanentlyDeleteJobsAfter` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `jobrunr_bgjobsrvrs_fsthb_idx` (`firstHeartbeat`),
  KEY `jobrunr_bgjobsrvrs_lsthb_idx` (`lastHeartbeat`)
) /*!50100 TABLESPACE `innodb_system` */ ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `jobrunr_jobs`
--

DROP TABLE IF EXISTS `jobrunr_jobs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `jobrunr_jobs` (
  `id` char(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `version` int(11) NOT NULL,
  `jobAsJson` mediumtext,
  `jobSignature` varchar(512) NOT NULL,
  `state` varchar(36) NOT NULL,
  `createdAt` datetime(6) NOT NULL,
  `updatedAt` datetime(6) NOT NULL,
  `scheduledAt` datetime(6) DEFAULT NULL,
  `recurringJobId` varchar(128) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `jobrunr_state_idx` (`state`),
  KEY `jobrunr_job_signature_idx` (`jobSignature`),
  KEY `jobrunr_job_created_at_idx` (`createdAt`),
  KEY `jobrunr_job_scheduled_at_idx` (`scheduledAt`),
  KEY `jobrunr_job_rci_idx` (`recurringJobId`),
  KEY `jobrunr_jobs_state_updated_idx` (`state`,`updatedAt`)
) /*!50100 TABLESPACE `innodb_system` */ ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Temporary view structure for view `jobrunr_jobs_stats`
--

DROP TABLE IF EXISTS `jobrunr_jobs_stats`;
/*!50001 DROP VIEW IF EXISTS `jobrunr_jobs_stats`*/;
SET @saved_cs_client     = @@character_set_client;
/*!50503 SET character_set_client = utf8mb4 */;
/*!50001 CREATE VIEW `jobrunr_jobs_stats` AS SELECT 
 1 AS `total`,
 1 AS `scheduled`,
 1 AS `enqueued`,
 1 AS `processing`,
 1 AS `failed`,
 1 AS `succeeded`,
 1 AS `allTimeSucceeded`,
 1 AS `deleted`,
 1 AS `nbrOfBackgroundJobServers`,
 1 AS `nbrOfRecurringJobs`*/;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `jobrunr_metadata`
--

DROP TABLE IF EXISTS `jobrunr_metadata`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `jobrunr_metadata` (
  `id` varchar(156) NOT NULL,
  `name` varchar(92) NOT NULL,
  `owner` varchar(64) NOT NULL,
  `value` text NOT NULL,
  `createdAt` datetime(6) NOT NULL,
  `updatedAt` datetime(6) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `jobrunr_migrations`
--

DROP TABLE IF EXISTS `jobrunr_migrations`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `jobrunr_migrations` (
  `id` char(36) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `script` varchar(64) NOT NULL,
  `installedOn` varchar(29) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `jobrunr_recurring_jobs`
--

DROP TABLE IF EXISTS `jobrunr_recurring_jobs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `jobrunr_recurring_jobs` (
  `id` char(128) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL,
  `version` int(11) NOT NULL,
  `jobAsJson` text NOT NULL,
  `createdAt` bigint(20) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `jobrunr_recurring_job_created_at_idx` (`createdAt`)
) /*!50100 TABLESPACE `innodb_system` */ ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `logs`
--

DROP TABLE IF EXISTS `logs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `logs` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `request_id` varchar(36) DEFAULT NULL,
  `session_id` varchar(36) DEFAULT NULL,
  `date` datetime(6) DEFAULT NULL,
  `level` varchar(10) DEFAULT NULL,
  `message` text,
  `payload` text,
  `user_id` varchar(36) DEFAULT NULL,
  PRIMARY KEY (`id`)
) /*!50100 TABLESPACE `innodb_system` */ ENGINE=InnoDB AUTO_INCREMENT=258932 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `question`
--

DROP TABLE IF EXISTS `question`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `question` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `question_type` int(11) DEFAULT NULL,
  `question_status` int(11) DEFAULT NULL,
  `question_text` text,
  `question_name` varchar(255) DEFAULT NULL,
  `question_domain_type` varchar(255) DEFAULT NULL,
  `options_json` json DEFAULT NULL,
  `exercise_attempt_id` bigint(20) NOT NULL,
  `domain_name` varchar(255) NOT NULL,
  `solution_facts` json NOT NULL,
  `statement_facts` json NOT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_QUESTION_ON_DOMAIN_NAME` (`domain_name`),
  KEY `FK_QUESTION_ON_EXERCISEATTEMPT` (`exercise_attempt_id`),
  CONSTRAINT `FK_QUESTION_ON_DOMAIN_NAME` FOREIGN KEY (`domain_name`) REFERENCES `domain` (`name`),
  CONSTRAINT `FK_QUESTION_ON_EXERCISEATTEMPT` FOREIGN KEY (`exercise_attempt_id`) REFERENCES `exercise_attempt` (`id`)
) /*!50100 TABLESPACE `innodb_system` */ ENGINE=InnoDB AUTO_INCREMENT=2157 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `question_attempt`
--

DROP TABLE IF EXISTS `question_attempt`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `question_attempt` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `question_request_log`
--

DROP TABLE IF EXISTS `question_request_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `question_request_log` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `exercise_attempt_id` bigint(20) DEFAULT NULL,
  `target_concept_names` json DEFAULT NULL,
  `target_concept_names_in_plan` json DEFAULT NULL,
  `denied_concept_names` json DEFAULT NULL,
  `allowed_concept_names` json DEFAULT NULL,
  `target_law_names` json DEFAULT NULL,
  `target_law_names_in_plan` json DEFAULT NULL,
  `denied_law_names` json DEFAULT NULL,
  `allowed_law_names` json DEFAULT NULL,
  `denied_question_names` json DEFAULT NULL,
  `denied_question_meta_ids` json DEFAULT NULL,
  `denied_question_template_ids` json DEFAULT NULL,
  `solving_duration` int(11) DEFAULT NULL,
  `complexity` double DEFAULT NULL,
  `complexity_search_direction` int(11) DEFAULT NULL,
  `laws_search_direction` int(11) DEFAULT NULL,
  `chance_to_pick_autogenerated_question` double DEFAULT '1',
  `found_count` int(11) DEFAULT '0',
  `created_date` datetime DEFAULT NULL,
  `domain_shortname` varchar(255) DEFAULT NULL,
  `concepts_denied_bitmask` bigint(20) NOT NULL,
  `concepts_targeted_bitmask` bigint(20) NOT NULL,
  `laws_denied_bitmask` bigint(20) NOT NULL,
  `laws_targeted_bitmask` bigint(20) NOT NULL,
  `trace_concepts_targeted_bitmask` bigint(20) NOT NULL,
  `steps_max` int(11) NOT NULL,
  `steps_min` int(11) NOT NULL,
  `outdated` int(11) DEFAULT '0',
  `processed_count` int(11) DEFAULT NULL,
  `last_processed_date` datetime(6) DEFAULT NULL,
  `added_questions` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) /*!50100 TABLESPACE `innodb_system` */ ENGINE=InnoDB AUTO_INCREMENT=94 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `questions_meta`
--

DROP TABLE IF EXISTS `questions_meta`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `questions_meta` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` text,
  `domain_shortname` varchar(45) NOT NULL DEFAULT 'ctrl_flow',
  `template_id` int(11) NOT NULL,
  `q_graph` text,
  `q_data_graph` text,
  `tag_bits` bigint(20) DEFAULT NULL,
  `concept_bits` bigint(20) DEFAULT NULL,
  `law_bits` bigint(20) DEFAULT NULL,
  `violation_bits` bigint(20) DEFAULT NULL,
  `trace_concept_bits` bigint(20) DEFAULT NULL,
  `solution_structural_complexity` double DEFAULT NULL,
  `integral_complexity` double DEFAULT NULL,
  `solution_steps` int(11) DEFAULT NULL,
  `distinct_errors_count` int(11) DEFAULT NULL,
  `_stage` int(11) DEFAULT NULL,
  `_version` int(11) DEFAULT NULL,
  `used_count` bigint(20) DEFAULT '0',
  `last_attempt_id` bigint(20) DEFAULT NULL,
  `structure_hash` varchar(1023) DEFAULT NULL,
  `date_last_used` datetime(6) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_domain_name` (`domain_shortname`)
) ENGINE=InnoDB AUTO_INCREMENT=30953 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `questions_meta_draft`
--

DROP TABLE IF EXISTS `questions_meta_draft`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `questions_meta_draft` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `origin` varchar(1023) DEFAULT NULL,
  `name` text,
  `domain_shortname` varchar(45) NOT NULL DEFAULT 'ctrl_flow',
  `template_id` int(11) NOT NULL,
  `qt_graph` varchar(1023) DEFAULT NULL,
  `qt_s_graph` varchar(1023) DEFAULT NULL,
  `q_graph` text,
  `q_s_graph` varchar(1023) DEFAULT NULL,
  `q_data_graph` text,
  `tag_bits` bigint(20) DEFAULT NULL,
  `concept_bits` bigint(20) DEFAULT NULL,
  `law_bits` bigint(20) DEFAULT NULL,
  `violation_bits` bigint(20) DEFAULT NULL,
  `trace_concept_bits` bigint(20) DEFAULT NULL,
  `solution_structural_complexity` double DEFAULT NULL,
  `integral_complexity` double DEFAULT NULL,
  `solution_steps` int(11) DEFAULT NULL,
  `distinct_errors_count` int(11) DEFAULT NULL,
  `_stage` int(11) DEFAULT NULL,
  `_version` int(11) DEFAULT NULL,
  `used_count` bigint(20) DEFAULT '0',
  `last_attempt_id` bigint(20) DEFAULT NULL,
  `structure_hash` varchar(1023) DEFAULT NULL,
  `date_last_used` datetime(6) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_domain_name` (`domain_shortname`)
) /*!50100 TABLESPACE `innodb_system` */ ENGINE=InnoDB AUTO_INCREMENT=16485 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `response`
--

DROP TABLE IF EXISTS `response`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `response` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `left_spec_value` int(11) DEFAULT NULL,
  `left_object_id` bigint(20) DEFAULT NULL,
  `right_object_id` bigint(20) DEFAULT NULL,
  `interaction_id` bigint(20) DEFAULT NULL,
  `created_by_interaction_id` bigint(20) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_RESPONSE_ON_INTERACTION` (`interaction_id`),
  KEY `FK_RESPONSE_ON_LEFTOBJECT` (`left_object_id`),
  KEY `FK_RESPONSE_ON_RIGHTOBJECT` (`right_object_id`),
  KEY `FK_RESPONSE_ON_CREATED_BY_INTERACTION` (`created_by_interaction_id`),
  CONSTRAINT `FK_RESPONSE_ON_CREATED_BY_INTERACTION` FOREIGN KEY (`created_by_interaction_id`) REFERENCES `interaction` (`id`),
  CONSTRAINT `FK_RESPONSE_ON_INTERACTION` FOREIGN KEY (`interaction_id`) REFERENCES `interaction` (`id`),
  CONSTRAINT `FK_RESPONSE_ON_LEFTOBJECT` FOREIGN KEY (`left_object_id`) REFERENCES `answer_object` (`id`),
  CONSTRAINT `FK_RESPONSE_ON_RIGHTOBJECT` FOREIGN KEY (`right_object_id`) REFERENCES `answer_object` (`id`)
) /*!50100 TABLESPACE `innodb_system` */ ENGINE=InnoDB AUTO_INCREMENT=12382 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `survey_answers`
--

DROP TABLE IF EXISTS `survey_answers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `survey_answers` (
  `survey_question_id` bigint(20) NOT NULL,
  `question_id` bigint(20) NOT NULL,
  `user_id` bigint(20) NOT NULL,
  `result` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`survey_question_id`,`question_id`,`user_id`),
  KEY `FK_SURVEYANSWERS_ON_QUESTION` (`question_id`),
  KEY `FK_SURVEYANSWERS_ON_USER` (`user_id`),
  CONSTRAINT `FK_SURVEYANSWERS_ON_QUESTION` FOREIGN KEY (`question_id`) REFERENCES `question` (`id`),
  CONSTRAINT `FK_SURVEYANSWERS_ON_SURVEY_QUESTION` FOREIGN KEY (`survey_question_id`) REFERENCES `survey_questions` (`id`),
  CONSTRAINT `FK_SURVEYANSWERS_ON_USER` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`)
) /*!50100 TABLESPACE `innodb_system` */ ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `survey_questions`
--

DROP TABLE IF EXISTS `survey_questions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `survey_questions` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `type` varchar(100) NOT NULL,
  `text` text NOT NULL,
  `options_json` json NOT NULL,
  `survey_id` varchar(255) DEFAULT NULL,
  `policy` json NOT NULL,
  `required` bit(1) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_SURVEYQUESTIONS_ON_SURVEY` (`survey_id`),
  CONSTRAINT `FK_SURVEYQUESTIONS_ON_SURVEY` FOREIGN KEY (`survey_id`) REFERENCES `surveys` (`id`)
) /*!50100 TABLESPACE `innodb_system` */ ENGINE=InnoDB AUTO_INCREMENT=12 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `surveys`
--

DROP TABLE IF EXISTS `surveys`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `surveys` (
  `id` varchar(255) NOT NULL,
  `name` varchar(255) NOT NULL,
  `options_json` json NOT NULL,
  PRIMARY KEY (`id`)
) /*!50100 TABLESPACE `innodb_system` */ ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `user`
--

DROP TABLE IF EXISTS `user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `user` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `first_name` varchar(255) DEFAULT NULL,
  `last_name` varchar(255) DEFAULT NULL,
  `password` varchar(255) DEFAULT NULL,
  `email` varchar(255) DEFAULT NULL,
  `birthdate` datetime DEFAULT NULL,
  `login` varchar(255) DEFAULT NULL,
  `external_id` varchar(255) DEFAULT NULL,
  `preferred_language` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `external_id_hidx` (`external_id`)
) /*!50100 TABLESPACE `innodb_system` */ ENGINE=InnoDB AUTO_INCREMENT=84 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `user_exercise`
--

DROP TABLE IF EXISTS `user_exercise`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `user_exercise` (
  `exercise_id` bigint(20) NOT NULL,
  `user_id` bigint(20) NOT NULL,
  PRIMARY KEY (`exercise_id`,`user_id`),
  KEY `fk_useexe_on_user_entity` (`user_id`),
  CONSTRAINT `fk_useexe_on_exercise_entity` FOREIGN KEY (`exercise_id`) REFERENCES `exercise` (`id`),
  CONSTRAINT `fk_useexe_on_user_entity` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`)
) /*!50100 TABLESPACE `innodb_system` */ ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `user_role`
--

DROP TABLE IF EXISTS `user_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `user_role` (
  `user_id` bigint(20) NOT NULL,
  `roles` varchar(255) DEFAULT NULL,
  KEY `fk_userrole_on_user_entity` (`user_id`),
  CONSTRAINT `fk_userrole_on_user_entity` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`)
) /*!50100 TABLESPACE `innodb_system` */ ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `violation`
--

DROP TABLE IF EXISTS `violation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `violation` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `interaction_id` bigint(20) NOT NULL,
  `law_name` varchar(255) NOT NULL,
  `detailed_law_name` varchar(255) DEFAULT NULL,
  `violation_facts` json NOT NULL,
  PRIMARY KEY (`id`),
  KEY `FK_VIOLATION_ON_INTERACTION` (`interaction_id`),
  CONSTRAINT `FK_VIOLATION_ON_INTERACTION` FOREIGN KEY (`interaction_id`) REFERENCES `interaction` (`id`)
) /*!50100 TABLESPACE `innodb_system` */ ENGINE=InnoDB AUTO_INCREMENT=906 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Final view structure for view `jobrunr_jobs_stats`
--

/*!50001 DROP VIEW IF EXISTS `jobrunr_jobs_stats`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_general_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`sa`@`%` SQL SECURITY DEFINER */
/*!50001 VIEW `jobrunr_jobs_stats` AS select coalesce(max((select `job_stat_results`.`count` from DUAL  where isnull(`job_stat_results`.`state`))),0) AS `total`,coalesce(max((select `job_stat_results`.`count` from DUAL  where (`job_stat_results`.`state` = 'SCHEDULED'))),0) AS `scheduled`,coalesce(max((select `job_stat_results`.`count` from DUAL  where (`job_stat_results`.`state` = 'ENQUEUED'))),0) AS `enqueued`,coalesce(max((select `job_stat_results`.`count` from DUAL  where (`job_stat_results`.`state` = 'PROCESSING'))),0) AS `processing`,coalesce(max((select `job_stat_results`.`count` from DUAL  where (`job_stat_results`.`state` = 'FAILED'))),0) AS `failed`,coalesce(max((select `job_stat_results`.`count` from DUAL  where (`job_stat_results`.`state` = 'SUCCEEDED'))),0) AS `succeeded`,coalesce((select cast(cast(`jm`.`value` as char(10) charset utf8mb4) as decimal(10,0)) from `jobrunr_metadata` `jm` where (`jm`.`id` = 'succeeded-jobs-counter-cluster')),0) AS `allTimeSucceeded`,coalesce(max((select `job_stat_results`.`count` from DUAL  where (`job_stat_results`.`state` = 'DELETED'))),0) AS `deleted`,(select count(0) from `jobrunr_backgroundjobservers`) AS `nbrOfBackgroundJobServers`,(select count(0) from `jobrunr_recurring_jobs`) AS `nbrOfRecurringJobs` from (select `jobrunr_jobs`.`state` AS `state`,count(0) AS `count` from `jobrunr_jobs` group by `jobrunr_jobs`.`state` with rollup) `job_stat_results` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2023-04-09 19:11:12
